package services {
	import model.ImageModel;

	import mx.collections.ArrayCollection;
	import mx.collections.ItemResponder;
	import mx.collections.ListCollectionView;
	import mx.rpc.AsyncToken;
	import mx.rpc.events.FaultEvent;
	import mx.rpc.events.ResultEvent;

	public class ImageSearchHistoryService extends ImageSearchService implements IImageSearchHistoryService {
		private var _searchHistory:ArrayCollection = new ArrayCollection();

		public function ImageSearchHistoryService(appid:String = 'YahooDemo') {
			super(appid);
		}

		override public function performSearch(query:String, resultCount:int = 10, resultFormat:String='e4x'):AsyncToken {
			var token:AsyncToken = super.performSearch(query, resultCount, resultFormat);
			token.addResponder(new ItemResponder(onResult, onFault, {query:query, resultCount:resultCount, resultFormat:resultFormat}));
			return token;
		}

		private function onResult(event:ResultEvent, token:Object = null):void {
			var images:Array = event.token.images;
			for each (var imageModel:ImageModel in images) {
				imageModel.searchTerm = token.query;
				_searchHistory.addItem(imageModel);
			}
		}

		private function onFault(event:FaultEvent, token:Object = null):void {
		}

		public function getSearchHistoryView():ListCollectionView {
			return new ListCollectionView(_searchHistory);
		}
		public function clearHistory():void {
			_searchHistory.removeAll();
		}
	}
}