package services {
	import model.ImageModel;
	import model.ImageModelUtil;

	import mx.collections.ItemResponder;
	import mx.rpc.AsyncToken;
	import mx.rpc.events.FaultEvent;
	import mx.rpc.events.ResultEvent;
	import mx.rpc.http.HTTPService;

	public class ImageSearchService implements IImageSearchService {
		public static const serviceURL:String = 'http://search.yahooapis.com/ImageSearchService/V1/imageSearch';
		public static const PARAM_APPID:String = 'appid';
		public static const PARAM_QUERY:String = 'query';
		public static const PARAM_TYPE:String = 'type';
		public static const PARAM_RESULTS:String = 'results';

		private var imageService:HTTPService = new HTTPService();
		private var _appid:String;

		public function ImageSearchService(appid:String = 'YahooDemo') {
			_appid = appid;
		}

		public function performSearch(query:String, resultCount:int = 10, resultFormat:String = 'e4x'):AsyncToken {
			imageService.resultFormat = resultFormat;

			var url:String = serviceURL + '?' + PARAM_APPID + '=' + _appid + '&' + PARAM_RESULTS + "=" + resultCount;
			if (query != null) {
				url = url + '&' + PARAM_QUERY + "=" + query;
			}
			imageService.url = url;

			var token:AsyncToken = imageService.send();
			token.addResponder(new ItemResponder(onSearchResult, onSearchFault));
			return token;
		}

		private function onSearchResult(event:ResultEvent, token:Object = null):void {
			var results:XMLList = (event.result as XML).*::Result;
			var images:Array = new Array();
			for each (var result:XML in results) {
				var imageModel:ImageModel = ImageModelUtil.populateImageFromYahoo(result);
				images.push(imageModel);
			}
			event.token.images = images;
		}
		private function onSearchFault(event:FaultEvent, token:Object = null):void {
		}
	}
}